/*
 * ************************************************************************************************************
 * Author: Marcin Załęczny
 * Copyright (C)2010 Marcin Załęczny <mzaleczny@hotmail.com>
 * License: The GNU Lesser General Public License, version 3.0 (LGPLv3)
 * Library Name: mzstdgraphics
 * Version: 1.05
 * First release date:   2010-11-08
 * Current release date: 2011-03-04
 *
 *
 * This file is part of mzstdgraphics library
 * 
 * mzstdgraphics library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * mzstdgraphics library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * ************************************************************************************************************
 */

#ifndef __MZSTDGRAPHICS_SPRITE_H__
#define __MZSTDGRAPHICS_SPRITE_H__

#include "mzstdgraphicsCommon.h"
#include "mzObject.h"
#include "mzString.h"

class CBitmap;

class DECLSPEC_MZSTDGRAPHICS CSprite : public CObject {
public:
    LONG x, y;
    LONG width, height;
    CBitmap *canvas;
    CString name;
    CSprite *parent;

    WINAPI CSprite(CSprite* parent, CString name, CBitmap *canvas, LONG x, LONG y);
    virtual WINAPI ~CSprite();
    virtual VOID WINAPI onDraw(CBitmap *dest);
    virtual RECT WINAPI getRect() {
        RECT rc;
        rc.left = 0;
        rc.top = 0;
        rc.right = this->width;
        rc.bottom = this->height;
        return rc;
    }

    virtual CString WINAPI getText();
    virtual VOID WINAPI setText(CString value, BOOL redraw = TRUE);
    
    virtual VOID WINAPI redraw();
    BOOL WINAPI pointIn(LONG x, LONG y);
    VOID WINAPI play(BOOL forward = TRUE);
    // jeśli ta metoda zwróci TRUE, to należy przerysować okienko
    virtual BOOL WINAPI update();

    VOID WINAPI setPosition(LONG x, LONG y) {
        this->x = x;
        this->y = y;
    }

	virtual inline VOID WINAPI addChild(CSprite *child) { return; }
    virtual inline VOID WINAPI prependChild(CSprite *child) { return; }
    virtual inline BOOL WINAPI removeChild(CSprite *child) { return FALSE; }
    virtual CSprite* WINAPI getChild(CString name) { return NULL; }

    BOOL inline WINAPI isPlaying() { return this->_step != 0; }
    VOID inline WINAPI stop() { this->_step = 0; }
    VOID inline WINAPI loop() { this->_looping = TRUE; }
    BOOL inline WINAPI isLooping() { return this->_looping; }
    VOID inline WINAPI setRewind(BOOL v) { this->_rewind = v; }
    BOOL inline WINAPI isRewind() { return this->_rewind; }
    VOID WINAPI forward();
    VOID WINAPI backward();
    virtual VOID WINAPI setSize(LONG width, LONG height);
	virtual VOID WINAPI setSizeRelativeToParent(LONG parentWidth, LONG parentHeight) {}
    VOID WINAPI setProportionalSizeRelativeToParent();
    VOID WINAPI setCanvas(CBitmap *canvas);
    inline BOOL WINAPI getAutosize() { return this->_autosize; };
    inline VOID WINAPI setAutoSize(BOOL autosize) { this->_autosize = autosize; };

    virtual VOID WINAPI invalidate();
    
    VOID inline WINAPI show() { if (!this->_visible) { this->_visible = TRUE; this->redraw(); } }
    virtual VOID WINAPI hide();
    BOOL WINAPI isVisible() { return this->_visible; }

    // Funkcja zwraca TRUE, jesli można do tego sprite'a przejść przy pomocy klawisza TabStop
    // (tzn. przekazać mu focus)
    BOOL WINAPI canTabStop() { return this->_visible && this->_enabled && this->_tabStop; }
    VOID WINAPI setTabStop(BOOL tabStop) { this->_tabStop = tabStop; }
    
    BOOL WINAPI isEnabled() { return this->_enabled; }
    virtual VOID WINAPI enable() { this->_enabled = TRUE; }
    virtual VOID WINAPI disable() { this->_enabled = FALSE; }
    
    VOID WINAPI enableTabkey() { this->_disableTabkey = FALSE; }
    VOID WINAPI disableTabkey() { this->_disableTabkey = TRUE; }
    BOOL WINAPI isTabkeyEnabled() { return !this->_disableTabkey; }

    VOID WINAPI doEnterAsTabkey(BOOL value) { this->_doEnterAsTabkey = value; }
    BOOL WINAPI isEnterAsTabkey() { return this->_doEnterAsTabkey; }
    
    VOID WINAPI setTransparentDrawing(BOOL value) { this->_transparentDrawing = value; }

protected:
    // stan sprite'a - wykorzystywany tylko przez niektóre klasy dziedziczące
    LONG _state;
    LONG _currentFrame;
    LONG _step;
    BOOL _looping;
    BOOL _rewind;
    // czy sprite jest widoczny
    BOOL _visible;
    // czy sprite jest dostępny
    BOOL _enabled;
    // czy do sprite'a można przejść przy pomocy klawisza Tab lub Shift+Tab
    BOOL _tabStop;
    // if TRUE then tab key is disabled if this sprite has focus
    BOOL _disableTabkey;
    // if TRUE then pressing ENTER key do the same as pressing TAB key
    BOOL _doEnterAsTabkey;

	// poniższy atrybut określa, czy przy zmianie rozmiaru okienka dany sprite ma
	// mieć rozmiar zmieniony relatywnie do swojego parenta
    BOOL _autosize;
    // atrybut określa czy w metodzie onDraw ma być wywołana metoda
    // updateCanvas odpowiedzialna za przerysowanie canvasu
    BOOL _needUpdate;
    // czy przy rysowaniu sprite'a uwzględniać kolory transparentne
    BOOL _transparentDrawing;
    // kolor, który wskazuje transparentne części bitmapy
    COLORREF _transparentColor;
    // bitmap filling color when creating canvas, default to this->_transparentColor
    COLORREF _backgroundColor;
    // Czy mamy zwolnić Canvas. Jeśli została wykonana metoda setSize, to tak.
    BOOL _destroyCanvas;

    virtual VOID WINAPI _updateCanvas() { this->_needUpdate = FALSE; };
	VOID WINAPI _commonInit(CString &name, CBitmap *canvas, LONG x, LONG y);
};

typedef CSprite* PSprite;

#endif
